// (PC-9801,2HD)t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*26*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{

	//	ȃf[^̈ʒu
	int md[] = { 
		0x01b0,	0x200,
		0x01b2,	0x200,
		0x01b4,	0x100,
		0x01b5,	0x100,
		0x01b6,	0x200,
		0x01b8,	0x300,
		0x01bb,	0x300,
		0x01be,	0x300,
		0x01c1,	0x300,
		0x01c4,	0x200,
		-1,		-1
	};

	char fname[FILENAME_MAX];
	int musnum=0;

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x010);

	// hCo
	fcut("PROG", 0x02, 0x01, 0x00, 0x01, 0x01, 0x0000, 0x8000);
	// I[vjOf
	fcut("OP",   0x1d, 0x0e, 0x01, 0x01, 0x01, 0x0000, 0x0f00);

	// ȃf[^
	for (int i=0; md[i*2]>0; i++) {
		int trk = md[i*2] / 16;
		int sec = md[i*2] % 16 +1;
		sprintf(fname,"MUS%02d",musnum++);
		fcut(fname, trk, trk>>1, trk&1, sec, 0x01, 0x0000, md[i*2+1]);
	}

	return 0;

}

